/*
* Code by Bodysoulspirit. Public Domain.
*/

#include "node.h"

VuoModuleMetadata({
					"title" : "Make Rounded Rectangle Object",
					"description" : "Creates a flat object shaded with a rounded rectangle.",
					"keywords" : ["pill"],
					"version" : "1.0.0",
});

void nodeEvent
(
  	VuoInputData(VuoColor, {"default":{"r":1,"g":1,"b":1,"a":1}}) color,
		VuoInputData(VuoReal, {"default":0.5}) sharpness,
		VuoInputData(VuoReal, {"default":0.5}) roundness,
		VuoInputData(VuoPoint3d) center,
		VuoInputData(VuoPoint3d) rotation,
		VuoInputData(VuoReal, {"default":1.0}) width,
		VuoInputData(VuoReal, {"default":1.0}) height,
		VuoOutputData(VuoSceneObject) quad
)
{
	VuoReal aspect = width/height;
	VuoShader shader = VuoShader_makeUnlitRoundedRectangleShader(color, sharpness, roundness, aspect);
	shader->isTransparent = true;
	*quad = VuoSceneObject_makeQuad(shader, center, rotation, width, height);
	VuoSceneObject_setName(*quad, VuoText_make("Rounded Rectangle"));
}
